//+------------------------------------------------------------------+
//|                                               Demo_trail_Buy.mq4 |
//|             Demo application                   2011,autor,Genkov |
//|          for trailing Buy position      genkov@bk.ru,kovgd@ya.ru |
//|            The application works                                 |
//|  in time interval from 2011.04.18 to 2011.04.22                  |
//+------------------------------------------------------------------+
#property copyright "2011,autor,Genkov"
#property link      "http://ForexkovTrade.com"
#property link      "http://Fxkom.narod.ru"
#property link      "http://forexparter.ucoz.ru/"
#property link      "http://forexmql.narod.ru/Runet.htm"
#property link      "http://forexchainik.narod.ru/"
#property link      "http://Animatyc.narod.ru" 
#property link      "http://genkov.baxonet.biz/"
#property link      "genkov@bk.ru , kovgd@ya.ru"
//+----------------------------------------------------------------------+
extern double SL_B=0;
extern double TP_B=0;
extern double Lots=0.1;
int Magic,i,d;
double Fb1,Fb2,Fb3,Fb4,Fb5,Fb6,Fb7,Fb8,Fb9,Fb10,Fb11,Fb12,Fb13;
double MedVegas,newSL_B,Ma144_1,Ma169_1;
//+----------------------------------------------------------------------+
void StoplevelFiboBuy()
  {
   double Fb1,Fb2,Fb3,Fb4,Fb5,Fb6,Fb7,Fb8,Fb9,Fb10,Fb11,Fb12,Fb13;
   double Ma144_1 = iMA(NULL,0,144,0,MODE_EMA,PRICE_CLOSE,1);
   double Ma169_1 = iMA(NULL,0,169,0,MODE_EMA,PRICE_CLOSE,1);
   double MedVegas=NormalizeDouble((Ma144_1+Ma169_1)/2,Digits);
   Fb1=MedVegas-377*Point;     Fb12=MedVegas+377*Point;
   Fb2=MedVegas-233*Point;     Fb11=MedVegas+233*Point;
   Fb3=MedVegas-144*Point;     Fb10=MedVegas+144*Point;
   Fb4=MedVegas-89*Point;      Fb9=MedVegas+89*Point;
   Fb5=MedVegas-55*Point;      Fb8=MedVegas+55*Point;
   Fb6=MedVegas-34*Point;      Fb7=MedVegas+34*Point;
   if(Low[1]>Fb12) newSL_B=Fb12-100*Point;
   if(Low[1]<=Fb12 && Low[1]>(Fb12+Fb11)/2)       newSL_B=(Fb12+Fb11)/2;
   if(Low[1]<=(Fb12+Fb11)/2 && Low[1]>Fb11)       newSL_B=Fb11;
   if(Low[1]<=Fb11 && Low[1]>(Fb11+Fb10)/2)       newSL_B=(Fb11+Fb10)/2;
   if(Low[1]<=(Fb10+Fb11)/2 && Low[1]>Fb10)       newSL_B=Fb10;
   if(Low[1]<=Fb10 && Low[1]>(Fb10+Fb9)/2)        newSL_B=Fb9;
   if(Low[1]<=(Fb10+Fb9)/2 && Low[1]>Fb9)         newSL_B=Fb8;
   if(Low[1]<=Fb9  && Low[1]>Fb8)                 newSL_B=Fb7;
   if(Low[1]<=Fb8  && Low[1]>Fb7)                 newSL_B=(Fb7+MedVegas)/2;
   if(Low[1]<=Fb7  && Low[1]>MedVegas)            newSL_B=Fb6;
   if(Low[1]<=MedVegas && Low[1]>(MedVegas+Fb6)/2)newSL_B=Fb6;
   if(Low[1]<=(MedVegas+Fb6)/2 && Low[1]>Fb6)     newSL_B=Fb5;
   if(Low[1]<=Fb6  && Low[1]>Fb5)                 newSL_B=Fb4;
   if(Low[1]<=Fb5  && Low[1]>Fb4)                 newSL_B=(Fb3+Fb4)/2;
   if(Low[1]<=Fb4  && Low[1]>Fb3)                 newSL_B=Fb3;
   if(Low[1]<=Fb3  && Low[1]>(Fb3+Fb2)/2)         newSL_B=(Fb3+Fb2)/2;
   if(Low[1]<=(Fb3+Fb2)/2  && Low[1]>Fb2)         newSL_B=Fb2;
   if(Low[1]<=Fb2  && Low[1]>(Fb2+Fb1)/2)         newSL_B=(Fb1+Fb2)/2;
   if(Low[1]<=(Fb2+Fb1)/2 && Low[1]>Fb1)          newSL_B=Fb1;
   if(Low[1]<=Fb1)                                newSL_B=Fb1-100*Point;
  }
// ----------------------------------------------------------------------+
void Modyf_B_lot()
  {
   if(!OrderModify(OrderTicket(),OrderOpenPrice(),newSL_B,
      OrderTakeProfit(),0,Aqua))
     {Print(" Modif.ord.# ",OrderTicket()," Error # ",GetLastError());}Mark();return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Close_B_lot()
  {
   if(!OrderClose(OrderTicket(),0.1,Bid,2,Gold))
     {Print(" Cl.ord.# ",OrderTicket()," Error # ",GetLastError());}MarkLeft();return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Op_Buy_Ch()
  {
   if(!OrderSend(Symbol(),OP_BUY,Lots,Ask,2,Bid-SL_B*Point,Ask+TP_B*Point," ",Magic,0,Blue))
     {Print("  SELL order opening error  # ",GetLastError());}MarkLeft1();return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Mark()
  {
   ObjectCreate("M"+d,OBJ_ARROW,0,TimeCurrent(),newSL_B);
   ObjectSet("M"+d,OBJPROP_COLOR,Red);ObjectSet("M"+d,OBJPROP_ARROWCODE,4);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void MarkLeft()
  {
   ObjectCreate("Mo"+d,OBJ_ARROW,0,TimeCurrent(),Ask);
   ObjectSet("Mo"+d,OBJPROP_COLOR,Gold);ObjectSet("Mo"+d,OBJPROP_ARROWCODE,5);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void MarkLeft1()
  {
   ObjectCreate("Mod"+d,OBJ_ARROW,0,TimeCurrent(),Ask);
   ObjectSet("Mod"+d,OBJPROP_COLOR,Aqua);ObjectSet("Mod"+d,OBJPROP_ARROWCODE,5);
  }
//+----------------------------------------------------------------------+
int start()
  {
   if(TimeCurrent()<StrToTime("2011.04.18"))return;
     {
      if(TimeCurrent()>StrToTime("2011.04.22")) return;
        {
         // ----------------------------------------------------------------------+
         int StopLevel=MarketInfo(Symbol(),MODE_STOPLEVEL);
         d=TimeCurrent();
         // ----------------------------------------------------------------------+
         if(Volume[0]>1) return;{if(Bid<1.4242 && Bid>1.4240)
           {
            Lots=0.2;
            SL_B=(Bid-Low[1])/Point+25;if(SL_B<=StopLevel) SL_B=StopLevel+5;
            TP_B=400;Op_Buy_Ch();Lots=0.1;
           }
        }
      // ======================================================================+
      //           ------------ TRAILING OPEN POSITIONS  ------------
      // ----------------------------------------------------------------------+
      for(int i=OrdersTotal()-1; i>=0; i--)
        {
         if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
           {Print("Order selection error = ",GetLastError());}
         if(OrderSymbol()==Symbol())
           {
            if(OrderType()==OP_BUY)
              {
               if(OrderMagicNumber()==Magic)
                 {
                  // ----------------------------------------------------------------------+
                  if((High[1]-OrderOpenPrice())>=SL_B*Point && OrderLots()==0.2)Close_B_lot();
                  // ----------------------------------------------------------------------+
                  if((High[1]-OrderOpenPrice())/Point>=100 && OrderLots()==0.1 && 
                     OrderStopLoss()<OrderOpenPrice())
                    {
                     Print(" 1 - StopLoss shift");
                     if(!OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+2*Point,
                        OrderTakeProfit(),0,Aqua))
                       {Print(" at Modif.ord.# ",OrderTicket()," Error # ",GetLastError());}return;
                    }
                  // ----------------------------------------------------------------------+
                  if((High[1]-OrderOpenPrice())>=120*Point && OrderOpenPrice()>Ma144_1-144*Point)
                    {
                     StoplevelFiboBuy();newSL_B=newSL_B+21*Point;
                     if((Bid-newSL_B)/Point<StopLevel)newSL_B=Bid-StopLevel*Point;
                     if(newSL_B>OrderStopLoss() && (Bid-newSL_B)/Point>StopLevel)
                       {
                        Print("2nd shift of StopLoss ");Modyf_B_lot();
                       }
                    }
                  // ----------------------------------------------------------------------+
                  if((High[1]-OrderOpenPrice())>=200*Point && (High[1]-OrderOpenPrice())<=250*Point)
                    {
                     StoplevelFiboBuy();if((Bid-newSL_B)/Point<StopLevel)newSL_B=Bid-StopLevel*Point;
                     if(newSL_B>OrderStopLoss() && (Bid-newSL_B)/Point>StopLevel)
                       {
                        Print(" 3rd shift by level order # ",OrderTicket());Modyf_B_lot();
                       }
                    }
                  // ----------------------------------------------------------------------+
                  if((High[1]-OrderOpenPrice())>=250*Point && OrderOpenPrice()>Ma144_1-144*Point)
                    {
                     StoplevelFiboBuy();newSL_B=newSL_B+10*Point;if((Bid-newSL_B)/Point<StopLevel)
                     newSL_B=Bid-StopLevel*Point;if(newSL_B>OrderStopLoss() && (Bid-newSL_B)/Point>StopLevel)
                       {Print(" 4th shift by level order # ",OrderTicket());Modyf_B_lot();}
                    }
                  // ----------------------------------------------------------------------+
                  if((High[1]-OrderOpenPrice())>=300*Point && (High[1]-OrderOpenPrice())<=350*Point)
                    {
                     StoplevelFiboBuy();newSL_B=newSL_B+20*Point;if((Bid-newSL_B)/Point<StopLevel)
                     newSL_B=Bid-StopLevel*Point;
                     if(newSL_B>OrderStopLoss() && (Bid-newSL_B)/Point>StopLevel)
                       {
                        Print(" 5th shift by level order # ",OrderTicket());Modyf_B_lot();
                       }
                    }
                  // ----------------------------------------------------------------------+
                  if((High[1]-OrderOpenPrice())>=350*Point && (High[1]-OrderOpenPrice())<=400*Point)
                    {
                     StoplevelFiboBuy();newSL_B=newSL_B+20*Point;
                     if((Bid-newSL_B)/Point<StopLevel)newSL_B=Bid-StopLevel*Point;
                     if(newSL_B>OrderStopLoss() && (Bid-newSL_B)/Point>StopLevel)
                       {
                        Print(" 6th shift by level order # ",OrderTicket());Modyf_B_lot();
                       }
                    }
                  // ----------------------------------------------------------------------+
                  if((High[1]-OrderOpenPrice())>=400*Point && (High[1]-OrderOpenPrice())<=500*Point)
                    {
                     StoplevelFiboBuy();if((Bid-newSL_B)/Point<StopLevel)newSL_B=Bid-StopLevel*Point;
                     if(newSL_B>OrderStopLoss() && (Bid-newSL_B)/Point>StopLevel)
                       {
                        Print(" 7th shift by level order # ",OrderTicket());Modyf_B_lot();
                       }
                    }
                  // ----------------------------------------------------------------------+
                  if((High[1]-OrderOpenPrice())>=500*Point && (High[1]-OrderOpenPrice())<=700*Point)
                    {
                     StoplevelFiboBuy();if((Bid-newSL_B)/Point<StopLevel)newSL_B=Bid-StopLevel*Point;
                     if(newSL_B>OrderStopLoss() && (Bid-newSL_B)/Point>StopLevel)
                       {
                        Print(" 8th shift by level order # ",OrderTicket());Modyf_B_lot();
                       }
                    }
                 }
              }
           }
        }
     }
  }return(0);
}
//+---------------------------------------------------------------------------+-------------------------------------------+
